from evennia import Command
from evennia.utils.evmenu import EvMenu
from evennia.commands.cmdhandler import CMD_LOGINSTART

from menus.login import plain_node_formatter


class CmdUnconnectedLook(Command):
    """
    look when in unlogged-in state

    Usage:
      look

    This is an unconnected version of the look command for simplicity.

    This is called by the server and kicks everything in gear.
    All it does is display the connect screen.
    """

    key = CMD_LOGINSTART
    aliases = ["look", "l"]
    locks = "cmd:all()"

    def func(self):
        """Show the connect screen."""
        EvMenu(
            self.caller,
            "menus.login",
            startnode="node_enter_username",
            auto_look=False,
            auto_quit=False,
            cmd_on_exit=None,
            node_formatter=plain_node_formatter,
        )

